#include <string>
#include <iostream>
using namespace std;

#define print
#ifdef printx
#define o(a) cout << #a << ": " << a << endl
#else
#define o(a)
#endif

void print_b(char b[9][9]) {
  char tmp[2] = { '.', ':' };
  int ind = 0;
  for(int j = 8; j > 0; j--) {
    cout << "+---+---+---+---+---+---+---+---+\n";
    for(int i = 1; i < 9; i++) {
      cout << "|" << tmp[ind];
      if(b[i][j] == 0)
        cout << tmp[ind];
      else
        cout << b[i][j];
      cout << tmp[ind];
      ind ^= 1;
    }
    cout << "|\n";
    ind ^= 1;
  }
  cout << "+---+---+---+---+---+---+---+---+" << endl;
}


int main(void) {
  char board[9][9];
  int i, j, len;
  int tolower = 'a' - 'A';
  string s;
  
  for(i = 1; i < 9; i++)
    for(j = 1; j < 9; j++)
      board[i][j] = 0;

  //white
  cin >> s;  //odlifruje white
  cin >> s;
  len = s.length();
  o(len);
  o(s);
  for(i = 0; i < len; ) {
    if(s[i] < 'a') {//neni pesec
      board[s[i + 1] - 'a' + 1][s[i + 2] - '0'] = s[i];
      i += 4;
    }
    else { //pesec
      board[s[i] - 'a' + 1][s[i + 1] - '0'] = 'P';
      i += 3;
    }
  }


//black
  cin >> s;  //odlifruje
  cin >> s;
  len = s.length();
  for(i = 0; i < len; ) {
    if(s[i] < 'a') {//neni pesec
      board[s[i + 1] - 'a' + 1][s[i + 2] - '0'] = s[i] + tolower;
      i += 4;
    }
    else { //pesec
      board[s[i] - 'a' + 1][s[i + 1] - '0'] = 'p';
      i += 3;
    }
  }
  
  print_b(board);
  
  
  return 0;
}
